﻿if (!app.documents.length > 0) {    // stop if no document is opened.
	alert("Sorry, No Current Document");
} else {
	var solidColorRef = new SolidColor();
	solidColorRef.rgb.hexValue = '000000';
	app.backgroundColor= solidColorRef;
	var originalInterpolation=app.preferences.interpolation;
	//app.preferences.interpolation=ResampleMethod.BICUBICSHARPER;
	app.preferences.interpolation=ResampleMethod.BICUBIC;
	var strtRulerUnits = app.preferences.rulerUnits;
	if (strtRulerUnits != Units.PIXELS) {
	    app.preferences.rulerUnits = Units.PIXELS; // selections are always in pixels
	}
	var origDoc = app.activeDocument;
	var w = origDoc.width;
	var h = origDoc.height;
	// creating mipmaps
	var mipW=w;
	var mipH=h;
	var canvasW=w;
	var originX=0;
	var sharpFactor=0.7;
	while (mipW>1 || mipH>1) {
		originCorners=new Array(Array(originX,0),Array(originX+mipW,0),Array(originX+mipW,mipH),Array(originX,mipH));
		origDoc.selection.select(originCorners);
		origDoc.selection.copy();
		canvasW=Math.ceil(canvasW+mipW/2);
		origDoc.resizeCanvas(canvasW,h,AnchorPosition.TOPLEFT);
		origDoc.selection.select(originCorners);
		var newLayer = origDoc.paste();
		origDoc.activeLayer = newLayer;
		if (mipW<=1 && mipH>1) {
			newLayer.resize(100,50,AnchorPosition.TOPLEFT);
			mipW=1;
		} else if (mipW>1 && mipH<=1) {
			newLayer.resize(50,100,AnchorPosition.TOPLEFT);
			mipH=1;
		} else if (mipW>1 && mipH>1){
			newLayer.resize(50,50,AnchorPosition.TOPLEFT);
		}
		newLayer.translate(mipW,0);
		newLayer.applyUnSharpMask(100,sharpFactor,0);
		newLayer=newLayer.duplicate();
		origDoc.activeLayer = newLayer;
		newLayer=newLayer.merge();
		newLayer=newLayer.duplicate();
		origDoc.activeLayer =newLayer;
		newLayer.merge();
		originX=originX+mipW;
		mipW=mipW/2;
		mipH=mipH/2;
		sharpFactor=sharpFactor/1.5;
		//if (mipW<1) mipW=1;
		//if (mipH<1) mipH=1;
	}
	origDoc.flatten();
	if (origDoc.channels.length==4) {
		var alpha=origDoc.channels[3];
		var alphaChannel = new Array(alpha);
		var theChannels =  new Array(origDoc.channels[0], origDoc.channels[1], origDoc.channels[2]);
		mipW=w;
		mipH=h;
		originX=0;
		while  (mipW>1 || mipH>1) {
			origDoc.activeChannels = alphaChannel;
			originCorners=new Array(Array(originX,0),Array(originX+mipW,0),Array(originX+mipW,mipH),Array(originX,mipH));
			origDoc.selection.select(originCorners);
			origDoc.selection.copy();
			// pasting as layer and transform
			origDoc.activeChannels = theChannels;
			origDoc.selection.select(originCorners);
			var newLayer = origDoc.paste();
			//origDoc.activeLayer = newLayer;
			newLayer.translate(mipW,0);
			if (mipW<=1 && mipH>1) {
				newLayer.resize(100,50,AnchorPosition.TOPLEFT);
				mipW=1;
			} else if (mipW>1 && mipH<=1) {
				newLayer.resize(50,100,AnchorPosition.TOPLEFT);
				mipH=1;
			} else if (mipW>1 && mipH>1){
				newLayer.resize(50,50,AnchorPosition.TOPLEFT);
			}
			newLayer.applyUnSharpMask(100,sharpFactor,0);
			newLayer=newLayer.duplicate();
			origDoc.activeLayer = newLayer;
			newLayer=newLayer.merge();
			origDoc.activeLayer = newLayer;
			newLayer=newLayer.duplicate();
			origDoc.activeLayer =newLayer;
			newLayer=newLayer.merge();
			origDoc.activeLayer = newLayer;
			originX=originX+mipW;
			mipW=mipW/2;
			mipH=mipH/2;
			sharpFactor=sharpFactor/1.5;
			//if (mipW<1) mipW=1;
			//if (mipH<1) mipH=1;
			// copying trasnformed channel
			originCorners=new Array(Array(originX,0),Array(originX+mipW,0),Array(originX+mipW,mipH),Array(originX,mipH));
			origDoc.selection.select(originCorners);
			origDoc.selection.copy();
			x=newLayer.remove();
			origDoc.activeChannels = alphaChannel;
			newLayer = origDoc.paste();
		}
		//origDoc.selection.selectAll();
		//origDoc.activeLayer.threshold(90);
		origDoc.selection.deselect();
		origDoc.activeChannels = theChannels;
	}
	app.preferences.interpolation=originalInterpolation;
}
// eof

